//********************************************************************
//*** ResourcePool/oracle/SQLSelect.t.cc
//*** Copyright (c) 2003-2005 by Markus Winand <mws@fatalmind.com>
//*** $Id: SQLSelect.t.cc,v 1.13 2005/03/12 13:41:25 mws Exp $
//********************************************************************
/*
This file is part of ResourcePool.

ResourcePool is free software; you can redistribute it
and/or modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2 of
the License, or (at your option) any later version.

ResourcePool is distributed in the hope that it will be
useful, but WITHOUT ANY WARRANTY; without even the implied warranty
of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with ResourcePool; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA
02111-1307  USA */

#include "ResourcePool/oracle/ResourcePool.hh"
#include "t/main.hh"

#include "testconfig.cc"
#include "../SQL/SQLSelect.t.cc"

std::auto_ptr<RP> rp;

void INIT_oracle_SQLSelect() {
	rp.reset(new RP(getFactory()));
	test_SQLSelect_init(*rp);
}

void TEST_oracle_SQLSelect_all() {
	test_SQLSelect_one(*rp);
}

void TEST_PERF_oracle_SQLSelect_all() {
	test_perf_SQLSelect_all(*rp);
}

void TEST_PERF_oracle_SQLSelect_ten() {
	test_perf_SQLSelect_ten(*rp);
}

void TEST_PERF_oracle_SQLSelect_one() {
	test_perf_SQLSelect_one(*rp);
}

void CLEANUP_oracle_SQLSelect() {
	test_SQLSelect_cleanup(*rp);
}
